api/config/routes.rb
Rails.application.routes.draw do
  resources :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root 'pages#index'
  get   'welcome' => 'pages#welcome', :as => 'welcome'
  get   'error' => 'pages#error', :as => 'error'
  get   'signin' => 'users#signin', :as => 'signin'
  post  'auth' => 'users#auth', :as => 'auth'
  get   'login' => 'users#login', :as => 'login'
  get   'lost' => 'users#lost', :as => 'lost'
  post   'resetpwd' => 'users#resetpwd', :as => 'resetpwd'
  get   'confirm_signin/:nickname/:token' => 'users#confirm_signin', :as => 'confirm_signin'
  get   'about' => 'pages#about', :as => 'about'
  get   'robots.txt' => 'pages#robots', :as => 'robots'
end

api/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

api/app/models/user.rb
class MailValidator < ActiveModel::Validator
  def validate(record)
     if (User::MAIL_VALIDATION_RULE =~ record.email).nil?
      record.errors[:base] << "This email is not valid"
    end
  end
end


class User < ApplicationRecord
  has_secure_password
  before_create :generate_token
  MAIL_VALIDATION_RULE = /(.+)[@](.+)[.](.+){1,8}/

  validates :email, presence: true, uniqueness: true
  validates :nickname, uniqueness: true, case_sensitive: false
  validates :password_digest, presence: true
  validates_with MailValidator

  def generate_token
    self.token = SecureRandom.uuid
    # Save new tocken only for registered user => do not save user for new user, the save is done once, controller 
    self.save if self.persisted?
  end

  def activate
  	self.active = true
  end
end

api/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

api/app/controllers/pages_controller.rb
class PagesController < ApplicationController
  # GET /
  def index
    
  end

  def welcome

  end
end

api/app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]
  before_action :init_user, only: [:new, :signin]
  protect_from_forgery prepend: true

  # GET /login
  # GET /login.json
  def login
  end

  def auth
    login_info = params.permit(:login, :password)
    login_col = (User::MAIL_VALIDATION_RULE =~ login_info[:login] ? "mail" : "nickname").to_sym
    @user = User.find_by(nickname: login_info[:login]).try(:authenticate, login_info[:password])
    
  end

  # GET /signin
  # GET /signin.json
  def signin
  end

  # GET /lost
  # GET /lost.json
  def lost
  end

  # GET /resetpwd
  # GET /resetpwd.json
  def resetpwd
    login_col = (User::MAIL_VALIDATION_RULE =~ params[:login] ? "mail" : "nickname").to_sym
    user = User.find_by(nickname: params[:login])
    if @user.instance_of? User
      @user.send_pwd_reset_link
    end
    abort params.inspect
  end

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end


  # GET /users/1
  # GET /users/1.json
  def show
  end

  # GET /users/new
  def new
  end

  # GET /users/1/edit
  def edit
  end

  def confirm_signin
    respond_to do |format|
      user = User.find_by(nickname: params[:nickname], token: params[:token])
      if user.nil?
        format.html { redirect_to error_path, notice: 'Link not valid.' }
        format.json { render :show, status: :ok}
      else
        user.activate
        user.save
        format.html { redirect_to welcome_path, notice: 'Your account have been actived' }
        format.json { render :show, status: :bad_request}
      end
    end
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        UserMailer.with(user: @user).welcome_email.deliver_now
        format.html { redirect_to welcome_path, notice: 'Your account was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        #format.html { redirect_to welcome_path(@user), notice: 'Your account was successfully updated.' }
        format.html { redirect_to @user, notice: 'Your account was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'Your account was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    def auth_user

    end

    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    def init_user
      @user = User.new
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def user_params
      params.require(:user).permit(:nickname, :email, :password, :password_confirmation)
    end
end

api/app/helpers/application_helper.rb
module ApplicationHelper
end

api/app/helpers/page_helper.rb
module PageHelper
end

api/app/helpers/users_helper.rb
module UsersHelper
end

api/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="fr-FR">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>App</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%# stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%# javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= session[:current_user_id].inspect %>
    <div class="header">
      <%= link_to root_path do %>
        <img src="" alt="App logo">
      <% end %>
    </div>

    <div class="container">
      <div class="menu">
        <ul class="list_item_menu">
          <% if !(current_page?(controller: 'users', action: 'signin')) %>
          <li class="item_menu">
            <%= link_to "signin", controller: 'users', action: 'signin' %>
          </li>
          <% end %>
          <% if !(current_page?(controller: 'users', action: 'login')) %>
          <li class="item_menu">
              <%= link_to "login", controller: 'users', action: 'login' %>
          </li>
          <% end %>
        </ul>
      </div>

      <% if flash[:notice] %>
        <div class="notice"><%= flash[:notice] %></div>
      <% end %>

      <div class="content">
        <%= yield %>
      </div>

      <div class="footer"></div>
    </div>
  </body>
</html>

api/app/views/pages/error.html.erb
Error

api/app/views/pages/welcome.html.erb
Welcome !

api/app/views/users/_form.html.erb
<%= form_with(model: user, local: true) do |form| %>
  <% if user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :nickname %>
    <%= form.text_field :nickname %>
  </div>

  <div class="field">
    <%= form.label :email %>
    <%= form.text_field :email %>
  </div>

  <div class="field">
    <%= form.label :password %>
    <%= form.password_field :password %>
  </div>

  <div class="field">
    <%= form.label :password_confirmation %>
    <%= form.password_field :password_confirmation %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

api/app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form', user: @user %>

<%= link_to 'Show', @user %> |
<%= link_to 'Back', users_path %>

api/app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Users</h1>

<table>
  <thead>
    <tr>
      <th>Email</th>
      <th>Nickname</th>
      <th>Created At</th>
      <th>Modified At</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.email %></td>
        <td><%= user.nickname %></td>
        <td><%= user.created_at %></td>
        <td><%= user.updated_at %></td>
        <td><%= link_to 'Show', user, class: 'btn btn-primary' %></td>
        <td><%= link_to 'Edit', edit_user_path(user), class: 'btn btn-primary' %></td>
        <td><%= link_to 'Destroy', user, method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-primary' %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New User', new_user_path, class: 'btn btn-primary' %>

api/app/views/users/login.html.erb
<%= form_tag "auth" do |form| %>
  <div class="field">
    <%= label_tag :login %>
    <%= text_field_tag :login, nil, placeholder: "Your nickname or your email address"%>
  </div>

  <div class="field">
    <%= label_tag :password %>
    <%= password_field_tag :password %>
  </div>

  <div class="actions">
    <%= submit_tag %>
  </div>
<% end %>

<%= link_to "Password lost ?", lost_path %>

api/app/views/users/lost.html.erb
<%= form_tag "resetpwd" do |form| %>
  <div class="field">
    <%= label_tag :login %>
    <%= text_field_tag :login, nil, placeholder: "Your nickname or your email address"%>
  </div>

  <div class="actions">
    <%= submit_tag %>
  </div>
<% end %>

api/app/views/users/new.html.erb
<h1>New User</h1>

<%= render 'form', user: @user %>

<%= link_to 'Back', users_path %>

api/app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Nickname:</strong>
  <%= @user.nickname %>
</p>

<p>
  <strong>Email:</strong>
  <%= @user.email %>
</p>

<%= link_to 'Edit', edit_user_path(@user) %> |
<%= link_to 'Back', users_path %>

api/app/views/users/signin.html.erb
<h1>Signin</h1>

<%= render 'form', user: @user %>

<%= link_to 'Back', users_path %>